<script lang="ts">
  import { onMount } from 'svelte';
  import { eventId, keycloak, settings } from '@stores';
  import { Gql } from '@db';
  import { Table, Tooltip } from '@sveltestrap/sveltestrap';
  import Fa from 'svelte-fa';
  import { faFlag as faFlagUnsolved } from '@fortawesome/free-regular-svg-icons';
  import { faEyeSlash, faFlag as faFlagSolved } from '@fortawesome/free-solid-svg-icons';
  import type { NullableEventRole } from '@auth/models';
  import type { Team } from '@models/Team';
  import { GetAllTeams } from '@models/Team';
  import { EventRole } from '@auth/models';

  type ScoreResponse = {
    score: {
      ctf: number;
      total: number;
      team: {
        id: string;
      };
    };
  };

  type ActiveChallengeData = {
    points: number;
    challenge: {
      id: string;
      name: string;
      category: string;
    };
    solves: Array<{
      team_id: string;
      team: {
        name: string;
        long_name: string;
      };
    }>;
  };

  type CtfProgressChallenge = ActiveChallengeData & {
    difficulty: keyof typeof flagDifficultyMap;
  };

  export let onHideTeam: (id: string) => void;
  export let visibleTeams: Record<string, boolean>;
  export let shortNames: boolean;
  export let show_scores = false;

  let queryRole: NullableEventRole;
  let categories: String[] = [];
  let challenges: CtfProgressChallenge[] = [];
  let scores: ScoreResponse[] = [];
  let scoreboardTeams: Team[] = [];
  let flagDifficultyMap = {
    0: 'text-success',
    1: 'text-warning',
    2: 'text-danger',
  };

  $: queryRole = $keycloak?.getFirstRole([
    EventRole.SuperAdmin,
    EventRole.EventAdmin,
    EventRole.CTFAdmin,
    EventRole.Staff,
    EventRole.Participant,
  ]);

  $: if (challenges) categories = [...new Set(challenges.map((v) => v.challenge.category))];

  onMount(async () => {
    scoreboardTeams = await GetAllTeams($eventId);

    Gql.subscribeSimple<{ scoreboard_team_summary: ScoreResponse[] }>(
      `subscription get_scores{
        scoreboard_team_summary(
          order_by: {order: asc},
          where: {event_id: {_eq: ${JSON.stringify($eventId)}}}
        ) {
          score {
            total
            team {
              id
            }
          }
        }
      }`,
      (data) => {
        scores = data.scoreboard_team_summary;
      },
      { role: queryRole },
    );

    Gql.subscribeSimple<{ challenges_active: ActiveChallengeData[] }>(
      // challenges_active(where: {released: {_eq: true}, event_id: {_eq: ${JSON.stringify($eventId)}}},
      `subscription getCTFProgress{
        challenges_active(where: {event_id: {_eq: ${JSON.stringify($eventId)}}},
        order_by: {challenge: {name: asc}}) {
          points
          challenge {
            id
            name
            category
          }
          solves {
            team_id
            team {
              name
              long_name
            }
          }
        }
      }`,
      (data) => {
        challenges = parseChallenges(data.challenges_active);
      },
      { role: queryRole },
    );
  });

  /*
   * Parses data after it's returned from the DB, adding in a difficulty rating and sorting by difficulty
   */
  function parseChallenges(chals: ActiveChallengeData[]): CtfProgressChallenge[] {
    const ret: CtfProgressChallenge[] = chals.map((chal) => ({
      ...chal,
      difficulty: getDifficulty(chal.points),
    }));

    // sort challenges by difficulty, but don't use the "sort" method, because
    // we want to maintain the alphabetical sorting from the database.
    // instead, add all difficulty 1 challenges to the start of the array in the same order
    return [
      ...ret.filter((ch) => ch.difficulty === 0),
      ...ret.filter((ch) => ch.difficulty === 1),
      ...ret.filter((ch) => ch.difficulty === 2),
    ];
  }

  function getDifficulty(points: number) {
    if (points > $settings.ctf.difficultyThresholds.easy && points <= $settings.ctf.difficultyThresholds.medium) {
      return 0;
    } else if (
      points > $settings.ctf.difficultyThresholds.medium &&
      points <= $settings.ctf.difficultyThresholds.hard
    ) {
      return 1;
    } else {
      return 2;
    }
  }
</script>

<div class="service-statuses">
  <Table>
    <thead>
      <tr>
        {#if $keycloak.isStaff()}
          <th />
        {/if}
        <th> Team</th>
        {#if show_scores}
          <th> Score</th>
        {/if}
        {#each categories as category}
          <th class="p0">
            <div class="sq sq-label sq-service text-start">
              {category}
            </div>
          </th>
        {/each}
      </tr>
    </thead>
    <tbody>
      {#each scoreboardTeams as team}
        {#if !(team.id in visibleTeams) || visibleTeams[team.id]}
          <tr>
            {#if $keycloak.isStaff()}
              <th class="pe-1">
                <span class="clickable" on:click={() => onHideTeam(team.id)}>
                  <Fa icon={faEyeSlash} />
                </span>
              </th>
            {/if}
            <th scope="row">
              <!-- 300px covers _most_ college names, but we want to set an upper limit -->
              <div style="max-width: 250px;">
                {team.name}
                {#if !shortNames && team.long_name}
                  <p class="my-0">{team.long_name}</p>
                {/if}
              </div>
            </th>
            {#if show_scores}
              <th>
                <span class="fs-2">{Math.floor(scores.find((s) => s.score.team.id == team.id)?.score.total)}</span>
              </th>
            {/if}
            {#each categories as category}
              <td>
                <div class="d-grid gap-2 px-1" style="grid-template-columns: repeat(4, fit-content(36px))">
                  {#each challenges.filter((ch) => ch.challenge.category === category) as ch}
                    <Fa
                      id="team-{team.id}-flag-{ch.challenge.id}"
                      icon={ch.solves?.some((s) => s.team_id === team.id) ? faFlagSolved : faFlagUnsolved}
                      class={flagDifficultyMap[ch.difficulty]}
                      size="2x"
                    />
                    <Tooltip target="team-{team.id}-flag-{ch.challenge.id}" placement="top">
                      {ch.challenge.name}
                    </Tooltip>
                  {/each}
                </div>
              </td>
            {/each}
          </tr>
        {/if}
      {/each}
    </tbody>
  </Table>
</div>

<style>
  .controls {
    /* Copied from bootstrap .input-group
     * to avoid straight edges on buttons
     */
    position: relative;
    display: flex;
    flex-wrap: wrap;
    align-items: stretch;
    width: 100%;
  }

  .service-statuses,
  .sq {
    display: flex;
    flex-flow: row nowrap;
    align-content: center;
    justify-content: center;
  }

  .sq {
    flex-flow: column nowrap;
  }

  .sq {
    color: white;
    border: 1px solid #252525;
    font-weight: bold;
    text-align: center;

    min-height: 2.5em;
    min-width: 4em;
  }

  .sq-label {
    border: 0;
    padding: 0 0.4em;
    text-shadow: 1px 1px 10px #888;
  }

  @media (max-width: 768px) {
    /* Transpose services display matrix */
    .service-statuses {
      flex-flow: column wrap;
      display: inline-flex;
      align-content: flex-start;
    }

    /* adjust row sizes, add banding effect, tilt team names upwards */
    .sq {
      font-size: 0.8em;
      min-height: 4em;
    }
  }

  /* Phonies */
  @media (max-width: 450px) {
    .sq {
      font-size: 0.6em;
      min-height: 5em;
    }

    .sq-service {
      font-size: 0.74em;
    }
  }

  .sq-service:first-child {
    /* Remove padding between first service and the table controls */
    padding-left: 0;
  }

  .sv-help-content {
    flex-direction: column;
    align-items: start;

    font-size: 1em;
    padding: 1em;
  }

  .sv-help-content .explain {
    font-size: 1.5em;
    font-weight: 700;
    padding: 0.4em;
  }
</style>
